<?
if (!defined('DOCROOT')) {
    $docroot = get_cfg_var('doc_root');
    define('DOCROOT', $docroot);
}
require_once (DOCROOT . '/include/services/AgentAuthenticator.phph');

/************* Agent Authentication ***************/

$sid = $_GET['sid'];
$account = AgentAuthenticator::authenticateSessionID($sid);

/************* End agent authentication ***********/

// Set up versioned namespace for the Connect PHP API
use RightNow\Connect\v1_4 as RNCPHP;
$context = RNCPHP\ConnectAPI::getCurrentContext();
$context->ApplicationContext = "SiteDownMonitor.php";

//----------- Ready to proceed with script --------//

class SiteDownNotifier {
    private $FileName = "/tmp/sitedowninfo.txt";

    public function __construct(){
        if(!file_exists($this->FileName)){
            $fh = fopen($this->FileName, "w");
            fwrite($fh, json_encode(new SiteDownInfo()));
            fclose($fh);
        }
    }

    public function siteDownCheck(){
        $info = json_decode(file_get_contents($this->FileName));
        if((time() - $info->Updated) > 10){
            $info = new SiteDownInfo();
            $fh = fopen($this->FileName, "w");
            fwrite($fh, json_encode($info));
            fclose($fh);
        }
        return $info;
    }

}

class SiteDownInfo {
    public $Incidents = array();
    public $Updated = null;
    public $SiteDown = false;

    public function __construct(){
        $this->Updated = time();
        $query = "SELECT ID, ReferenceNumber, Subject, Product.LookupName AS 'Product' FROM Incident WHERE Severity.ID = 1 AND StatusWithType.StatusType.ID != 2 AND AssignedTo.Account IS NULL";
        $roql = RNCPHP\ROQL::query($query)->next();
        if($roql->count()>0){
            $this->SiteDown = true;
            while($row = $roql->next()){
                $this->Incidents[] = new SRData($row);
            }
        }
    }

}

class SRData {
    public $ID = null;
    public $Subject = null;
    public $Product = null;
    public $ReferenceNumber = null;
    public $UpdateToExisting = null;

    public function __construct($row){
        $this->ID = $row['ID'];
        $this->Subject = $row['Subject'];
        $this->Product = $row['Product'];
        $this->ReferenceNumber = $row['ReferenceNumber'];
        $this->UpdateToExisting = $this->isUpdate();
    }

    private function isUpdate(){
        //Use business-specific logic here to determine whether this is an existing Sev1 being updated, or if it has just been raised to Sev1 
        return false; //Default. Not an update. 
    }
}

$siteDownNotifier = new SiteDownNotifier();

echo json_encode($siteDownNotifier->siteDownCheck());


?>