﻿using System;
using RightNow.AddIns.AddInViews;
using System.Windows.Forms;
using System.Drawing;
using System.AddIn;
using System.Media;

namespace SiteDownPinger
{
   public static class addinConfiguration
   {
      public static string ringerConfigID = "";
      public static string excludedAccounts = "";
      public static string includedAccounts = "";
   }

   [AddIn("Site Notif Addin", Version = "3.0.0.0")]
   public class SitePingerAddin : IStatusBarItem
   {
      private System.Windows.Forms.Button agentButton;
      private IGlobalContext _context;
      //private string[] incidents;
      SoundPlayer notifier;
      private int ringerCount = 3;
      private int totalSrs = 0;
      public static IGlobalContext GlobalContext;
      private SiteDownChecker SiteDownChecker;
      private SiteDownInfo SiteDownInfo { get; set; }
      private System.Timers.Timer Poller;


      bool IAddInBase.Initialize(IGlobalContext context)
      {
         GlobalContext = context;
         SiteDownChecker = new SiteDownChecker();
         return true;
      }

      public void stopPoller()
      {

      }

      private void playSound(int incomingSRs)
      {
         if (ringerCount == 3 || incomingSRs != totalSrs)
         {
            notifier.Play();
            totalSrs = incomingSRs;
            ringerCount = 0;
         }
         else
         {
            ringerCount = ringerCount + 1;
         }
      }

      private void resetButton()
      {
         agentButton.Text = "No Unassigned Site Downs";
         agentButton.BackColor = Color.Green;
         agentButton.ForeColor = Color.White;
         ringerCount = 0;
         totalSrs = 0;
      }

      private void buttonClicked(object sender, EventArgs e)
      {
         if (SiteDownInfo != null && SiteDownInfo.Incidents.Count > 0)
         {
            ContextMenuStrip popup = new ContextMenuStrip();
            ToolStripItem[] incList = new ToolStripItem[SiteDownInfo.Incidents.Count];
            for (int i = 0; i < SiteDownInfo.Incidents.Count; i++)
            {
               Incident sRData = SiteDownInfo.Incidents[i];
               ToolStripMenuItem itm = new ToolStripMenuItem(sRData.ReferenceNumber + " Product:" + sRData.Product + " Subject:" + sRData.Subject + "...");
               itm.Name = sRData.ID.ToString();
               itm.Click += _contextMenuClick;
               if (sRData.UpdateToExisting)
               {
                  itm.BackColor = Color.Orange;
               }
               else
               {
                  itm.BackColor = Color.Red;
               }
               incList[i] = itm;
            }
            popup.Items.AddRange(incList);
            Point pt = new Point(agentButton.Location.X, agentButton.Location.Y - 75);
            popup.Show(agentButton, pt);
         }
      }

      private void _contextMenuClick(object sender, EventArgs e)
      {
         ToolStripItem itm = (ToolStripItem)sender;
         IRecordContext incidentRecord = _context.AutomationContext.EditWorkspaceRecord("Incident", Convert.ToInt32(itm.Name));
      }


      private void _runSiteDownCheck(object sender, EventArgs e)
      {
         SiteDownInfo = SiteDownChecker.CheckSiteDowns();

         if (SiteDownInfo.SiteDown && SiteDownInfo.Incidents.Count > 0)
         {
            playSound(SiteDownInfo.Incidents.Count); //Call this if site downs found
            agentButton.Text = "Unassigned Site Downs: " + SiteDownInfo.Incidents.Count.ToString();

            //Color the button red if there are newly created or escalated site downs, orange otherwise
            if (SiteDownInfo.HasNewSiteDowns())
            {
               agentButton.BackColor = Color.Red;
            }
            else
            {
               agentButton.BackColor = Color.Orange;
            }

            agentButton.ForeColor = Color.Black;

         }
         else
         {
            resetButton(); //Call this if no site downs
         }


      }

      System.Windows.Forms.Control IAddInControl.GetControl()
      {
         agentButton = new System.Windows.Forms.Button();
         agentButton.TabStop = false;
         agentButton.FlatStyle = FlatStyle.Popup;
         agentButton.FlatAppearance.BorderSize = 0;
         agentButton.FlatAppearance.BorderColor = Color.White;
         agentButton.Padding = new Padding(0, 0, 0, 0);
         agentButton.Font = new System.Drawing.Font("Microsoft Sans Serif", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
         agentButton.Margin = new Padding(0, 0, 0, 0);
         agentButton.Width = 300;
         agentButton.Height = 25;
         agentButton.BackColor = Color.White;
         agentButton.ImageAlign = ContentAlignment.TopCenter;
         agentButton.AutoSize = true;
         agentButton.AutoSizeMode = AutoSizeMode.GrowAndShrink;
         agentButton.TextAlign = ContentAlignment.TopCenter;
         agentButton.Text = "Site Pinger Not Loaded";
         agentButton.Click += new System.EventHandler(this.buttonClicked);

         return agentButton;
      }

   }
}
